#include <stdio.h>
#include <stdlib.h>
#include <cuda.h>
#include <cuda_runtime.h>

#define N (32)

__global__ void inc(int *array, int len)
{
    int i;
    int tid = threadIdx.x;
    int nthreads = blockDim.x;
    int part = len / nthreads;
    for (i = part * tid; i < part * (tid + 1); i++)
        array[i]++;
    return;
}

int main(int argc, char *argv[])
{
    int i;
    int arrayH[N];
    int *arrayD;
    size_t array_size;
    for (i=0; i<N; i++)
        arrayH[i] = i;
    printf("input: ");
    for (i=0; i<N; i++)
        printf("%d ", arrayH[i]);
    printf("\n");

    array_size = sizeof(int) * N;
    cudaMalloc((void **)&arrayD, array_size);
    cudaMemcpy(arrayD, arrayH, array_size, cudaMemcpyHostToDevice);
    inc<<<1, N>>>(arrayD, N);
    cudaMemcpy(arrayH, arrayD, array_size, cudaMemcpyDeviceToHost);
    printf("output: ");
    for (i=0; i<N; i++)
        printf("%d ", arrayH[i]);
    printf("\n");
    return 0;
}

